 MEMBER
 INCLUDE('cProcess.inc'),ONCE
 MAP
    wndEnumWindow(ulong hWnd,ulong lParam),bool,pascal ! callback  EnumWindows
 END
QAWINDOW    queue(QAWINDOWS). !      
! ***************************************************************************************
cProcess.GetActiveWindows function(QAWINDOWS qWindows) !    
locReturnValue byte
 code
 locReturnValue=0 !  
 free(qWindows)
 free(QAWINDOW)
 if ~EnumWindows(wndEnumWindow,1)
    locReturnValue=1
 else
    loop i#=1 to records(QAWINDOW)
       get(QAWINDOW,i#)
       qWindows.WndName=QAWINDOW.WndName
       qWindows.hWindow=QAWINDOW.hWindow
       qWindows.PID=QAWINDOW.PID
       add(qWindows)
    end
 end
 return(locReturnValue)
! ***************************************************************************************
cProcess.KillProcess  function(ulong hWnd) !  
locExitCode    long
locReturnValue ulong
locdwProcessId ulong
lochProcess    ulong
 code
 locReturnValue=0 !  
 locExitCode=0
 i#=GetWindowThreadProcessId(hWnd, locdwProcessId)
 lochProcess=OpenProcess(PROCESS_QUERY_INFORMATION+PROCESS_TERMINATE,False, locdwProcessId)
 if lochProcess<>0
    if GetExitCodeProcess(lochProcess, locExitCode)
       if ~TerminateProcess(lochProcess, locExitCode)
          locReturnValue=1
       else
          CloseHandle(lochProcess)
       end
    else
       locReturnValue=1
    end
 else
    locReturnValue=1
 end
 return(locReturnValue)
! ***************************************************************************************
cProcess.ShowWndText function(ulong hWnd,string WinTitle) !    
cstrWinTitle cstring(256)
ReturnValue  byte
 code
 ReturnValue=0 !  
 cstrWinTitle=clip(WinTitle)
 if ~SetWindowText(hWnd,cstrWinTitle) then ReturnValue=1.
 return(ReturnValue)
! ***************************************************************************************
cProcess.GetWndText function(ulong hWnd) !   
cstrWinTitle cstring(256)
 code
 if ~GetWindowText(hWnd,cstrWinTitle,size(cstrWinTitle)) then cstrWinTitle=''.
 return(cstrWinTitle)
! ***************************************************************************************
cProcess.ProcessExist function(ulong hWnd) !   
ReturnValue    byte
locdwProcessId ulong
locQAWINDOW    queue(QAWINDOWS).
 code
 ReturnValue=0 !  
 i#=GetWindowThreadProcessId(hWnd, locdwProcessId)
 if ~self.GetActiveWindows(locQAWINDOW)
    loop i#=1 to records(locQAWINDOW)
       get(locQAWINDOW,i#)
       if locQAWINDOW.PID=locdwProcessId
          ReturnValue=1
          break
       end
    end
 end
 return(ReturnValue)
! ***************************************************************************************
cProcess.StartProcess function(string FileName,string WorkDirectory) !  
ReturnValue           byte
locApplicationName    cstring(256)
locCommandLine        cstring(256)
locCurrentDirectory   cstring(256)
ProcessAttributes     like(SECURITY_ATTRIBUTES)
ThreadAttributes      like(SECURITY_ATTRIBUTES)
locEnvironment        long
locStartupInfo        like(STARTUPINFO)
locReserved           long
locProcessInformation like(PROCESS_INFORMATION)
bInheritHandles       bool
 code
 ReturnValue=0 !  
 locApplicationName=clip(FileName)
 locCommandLine=''
 locEnvironment=0
 locCurrentDirectory=clip(WorkDirectory)

 ProcessAttributes.nLength=size(SECURITY_ATTRIBUTES)
 ProcessAttributes.lpSecurityDescriptor=0
 ProcessAttributes.bInheritHandle=False

 ThreadAttributes.nLength=size(SECURITY_ATTRIBUTES)
 ThreadAttributes.lpSecurityDescriptor=0
 ThreadAttributes.bInheritHandle=False

 bInheritHandles=False
 locReserved=0

 clear(locStartupInfo)
 locStartupInfo.cb=size(STARTUPINFO)
 locStartupInfo.dwFlags=STARTF_USESHOWWINDOW

 if CreateProcess(locApplicationName, |
                  locCommandLine,           |
                  0,        |
                  0,         |
                  0,          |
                  CREATE_NEW_PROCESS_GROUP+NORMAL_PRIORITY_CLASS, |
                  0,        |
                  locCurrentDirectory,   |
                  locStartupInfo,        |
                  locProcessInformation)
  end
  SELF.hProcess = locProcessInformation.hProcess
  return(locProcessInformation.dwProcessId)
! ***************************************************************************************
cProcess.GethWndByPID function(ulong locPID) !      PID
locQAWINDOW           queue(QAWINDOWS).
ReturnValue           ulong
 code
 ReturnValue=0 !  
 if ~self.GetActiveWindows(locQAWINDOW)
    loop i#=1 to records(locQAWINDOW)
       get(locQAWINDOW,i#)
       if locPID=locQAWINDOW.PID
          ReturnValue=locQAWINDOW.hWindow
          break
       end
    end
 end
 return(ReturnValue)
! ***************************************************************************************
wndEnumWindow function(ulong hWnd,ulong lParam) ! callback  EnumWindows
locTitleName   cstring(256)
locdwProcessId ulong
 code
 if ~GetWindowText(hWnd,locTitleName,size(locTitleName)) then locTitleName='Unknown'.
 i#=GetWindowThreadProcessId(hWnd, locdwProcessId)
 QAWINDOW.WndName=clip(locTitleName)
 QAWINDOW.hWindow=hWnd
 QAWINDOW.PID=locdwProcessId
 add(QAWINDOW)
 return TRUE
